REM Programm zum Lesen und Schreiben eine  Microcontrollers
REM ueber den Paralellport des PC
REM Microcontroller des Typs  AT 89 S 8252
REM RESET ueber Freigabe Signal gesteuert von Strobe
REM SCK Signal ueber D7 des Parallelports
REM MOSI Signal ueber D0 des Paralllelports
REM MISO Signal ueber Select Signal des Parallelports
REM----------------------------------------------------
CLS
port = &H378: REM LPT 1
DIM WERT(8192 + 10)
plen = 8191: REM Laenge Datenspeicher
dlen = 2047: REM Laenge Programmspeicher
REM----------------------------------------------------
GOSUB SPIinit
SLEEP (1)
CLS
LOCATE 5, 1
PRINT "       P r o g r a m m   z u r   P r o g r a m m i e r u n g   d e r "
PRINT
PRINT "          M i c r o c o n t r o l l e r    d e s    T y p s "
PRINT
PRINT "                A T M E L     A T  8 9 S 8 2 5 2    "
PRINT
PRINT "     v o n    A n d r e a s   K o e h l e r    D e s s a u   2 0 0 1"
SLEEP (1)
menue1:
CLS
LOCATE 5, 1
PRINT "    Loeschen  eines Controllerchips ........................   1"
PRINT
PRINT "    Lesen des Programmcodespeichers ........................   2"
PRINT
PRINT "    Schreiben des Programmcodespeichers ....................   3"
PRINT
PRINT "    Schreiben des Datenspeichers ...........................   4"
PRINT
PRINT "    Lesen des Datenspeichers  ..............................   5"
PRINT
PRINT "    Look Bits im Controller setzen .........................   6"
PRINT
PRINT "    Datei laden ............................................   7"
PRINT
PRINT "    Datei speichern ........................................   8"
PRINT
PRINT "    HEXA-DUMP Speicher .....................................   9 "
PRINT
PRINT "    Programm beenden .......................................   0"
PRINT
INPUT "    Ihre Eingabe   : "; EIN
IF (EIN < 0) THEN BEEP: GOTO menue1
IF (EIN > 9) THEN BEEP: GOTO menue1
IF EIN = 0 GOTO ENDE
ON EIN GOSUB ERACHIP, LPROG, SPROG, SDATS, LDATS, LOOK, DATLE, DATSP, DUMP
GOTO menue1
ENDE:
CLS
LOCATE 5, 1
PRINT " E n d e    d e s   P r o g r a m m i e r p r o g r a m m s   f u e r "
PRINT
PRINT "  M i c r o c o n t r o l l e r   d e s  T y p s   A T  8 9  C  8 2 5 2"
PRINT
PRINT "   v o n   A n d r e a s   K o e h l e r     D e s s a u     2 0 0 1 "
END
REM ---------------------------------------------------
REM Lesen des Programmspeichers
LPROG:   
CLS
LOCATE 5, 1
PRINT " L e s e n   d e s   C o n t r o l l e r p r o g r a m m s p e i c h e r s "
PRINT
PRINT
GOSUB PROGFREI
FOR H = 0 TO plen: REM 0 ... 8191
WERT(H) = 255
NEXT H
FOR H = 0 TO plen: REM 0 ... 8191
highadr = INT(H / 256)
highadr = highadr * 8
highadr = highadr OR 1
lowadr = H AND 255
LOCATE 10, 1
PRINT "                           "
LOCATE 10, 1
PRINT "Adresse   : "; HEX$(H)
Byte = highadr
GOSUB SPIout
Byte = lowadr
GOSUB SPIout
GOSUB SPIin
WERT(H) = iwert
LOCATE 10, 30
PRINT "                           "
LOCATE 10, 30
PRINT " Bytewert : "; HEX$(iwert)
NEXT H
GOSUB SPIinit
RETURN
REM----------------------------------------------------
REM Schreiben des Programmspeichers
SPROG:
CLS
LOCATE 5, 1
PRINT "P r o g r a m m i e r e n   d e s   P r o g r a m m s p e i c h e r s"
GOSUB PROGFREI
FOR H = 0 TO plen
highadr = INT(H / 256)
highadr = highadr * 8
highadr = highadr OR 2
lowadr = H AND 255
LOCATE 10, 1
PRINT "                         "
LOCATE 10, 1
PRINT "Adresse    : "; HEX$(H)
Byte = highadr
GOSUB SPIout
Byte = lowadr
GOSUB SPIout
Byte = WERT(H)
GOSUB SPIout
LOCATE 10, 30
PRINT "                             "
LOCATE 10, 30
PRINT "Bytewert : "; HEX$(Byte)
NEXT H
GOSUB SPIinit
RETURN
REM-----------------------------------------------------
REM Schreiben des Datenspeichers
SDATS:
CLS
LOCATE 5, 1
PRINT " P r o g r a m m i e r u n g   d e s   D a t e n s p e i c h e r s "
GOSUB PROGFREI
FOR H = 0 TO dlen: REM 0...2047
highadr = INT(H / 256)
highadr = highadr * 8
highadr = highadr OR 6
lowadr = H AND 255
Byte = highadr OR 6
GOSUB SPIout
Byte = lowadr
GOSUB SPIout
Byte = WERT(H)
GOSUB SPIout
LOCATE 10, 1
PRINT "Adresse     : "; HEX$(H)
LOCATE 10, 40
PRINT "Bytewert    : "; HEX$(WERT(H))
NEXT H
GOSUB SPIinit
RETURN
REM-----------------------------------------------------
REM Auslesen des Datenspeichers des Prozessors
LDATS:
CLS
LOCATE 5, 1
PRINT " L e s e n   d e s    D a t e n s p e i c h e r s "
GOSUB PROGFREI
FOR H = 0 TO dlen: REM 0 ... 2047
highadr = INT(H / 256)
highadr = highadr * 8
lowadr = H AND 255
Byte = highadr OR 5
GOSUB SPIout
Byte = lowadr
GOSUB SPIout
GOSUB SPIin
WERT(H) = iwert
LOCATE 10, 1
PRINT "                         "
LOCATE 10, 1
PRINT "Adresse     : "; HEX$(H)
LOCATE 10, 40
PRINT "                         "
LOCATE 10, 40
PRINT "Bytewert    : "; HEX$(WERT(H))
NEXT H
GOSUB SPIinit
RETURN
REM-----------------------------------------------------
REM Setzen der Look Bits im Prozessor um weitere Zugriffe
REM zu sperren
LOOK:
LB = 0: REM Grundzustand Lookbit
LBM$ = ""
LOOK1:
CLS
LOCATE 5, 1
PRINT " S e t z e n   d e r   L o o k b i t s   i m   C o n t r o l l e r "
PRINT
PRINT " W e l c h e  L o o k b i t s   s o l l e n   g e s e t z t   w e r d e n ?"
PRINT
PRINT " L o o k b i t 1   ( MOVC disabled ) ...................     1"
PRINT
PRINT " L o o k b i t 2   ( Verify disabled ) .................     2"
PRINT
PRINT " L o o k b i t 3   ( Extern Execute disabled ) .........     3"
PRINT
PRINT " A u s w a h l   f e r t i g  ..........................     4"
PRINT
PRINT " Gesetzte Lookbits  :"; LBM$
PRINT
INPUT " Ihre Eingabe  :"; LB
IF LB < 1 THEN BEEP: GOTO LOOK1
IF LB > 4 THEN BEEP: GOTO LOOK1
ON LB GOTO LBIT1, LBIT2, LBIT3, LBEND
LBEND:
GOSUB PROGFREI
Byte = &HAC
GOSUB SPIout
Byte = LB OR 7
GOSUB SPIout
Byte = &H0
GOSUB SPIout
GOSUB SPIinit
RETURN
LBIT1:
LB = LB OR 128
LBM$ = LBM$ + "1"
GOTO LOOK1
LBIT2:
LB = LB OR 64
LBM$ = LBM$ + "2"
GOTO LOOK1
LBIT3:
LB = LB OR 32
LBM$ = LBM$ + "3"
GOTO LOOK1
REM ----------------------------------------------------
REM Freigabe der Programmierung
PROGFREI:
GOSUB FREI
FOR T = 1 TO 1000
NEXT T
Byte = &HAC: REM Programmierung enable 1
GOSUB SPIout
Byte = &H53: REM Programmierung enable 2
GOSUB SPIout
Byte = &H0: REM Programmierung enable 3
GOSUB SPIout
RETURN
REM-------------------------------------------------------
REM Loeschen des gesamten Controllerchips
ERACHIP:
CLS
LOCATE 5, 1
PRINT " L o e s c h e n    d e s   g e s a m t e n   C h i p s "
PRINT
PRINT " B i t t e   e i n e n   M o m e n t   w a r t e n  "
GOSUB PROGFREI
Byte = &HAC: REM Erase Chip byte 1
GOSUB SPIout
Byte = &H4: REM Erase Chip Byte 2
GOSUB SPIout
Byte = &H0: REM Erase Chip Byte 3
GOSUB SPIout
SLEEP (2)
PRINT
PRINT "   S p e i c h e r  w u r d e   g e l o e s c h t "
SLEEP (1)
GOSUB SPIinit
RETURN
REM---------------------------------------------------------------
REM Lesen der Programmierdaten von einem Datentraeger
DATLE:
CLS
DALE1:
LOCATE 5, 1
PRINT " D a t e i l e s e n   v o m   D a t e n t r a e g e r "
PRINT
PRINT
PRINT
PRINT " Binaerdatei fuer Programmspeicher lesen ..........    1"
PRINT
PRINT " Binaerdatei fuer Datenspeicher lesen .............    2"
PRINT
PRINT " zum Hauptmenue zurueck ...........................    3"
PRINT
INPUT "Ihre Wahl  :"; DL
IF (DL < 1) THEN GOTO DALE1
IF (DL > 3) THEN GOTO DALE1
IF (DL = 3) THEN GOTO DTLEN
ON DL GOSUB PSBINLE, DSBINLE
GOTO DALE1
DTLEN:
RETURN
REM --------------------------------------------------------------
REM Lesen einer Datei fuer den Programmspeicher binaer
PSBINLE:
CLS
LOCATE 5, 5
PRINT " Lesen einer Datei fuer den Programmspeicher des AT 89 S 8252"
PRINT
PRINT "         Bereich  0 ... 1FFFH   ( 8192 Byte ) "
PRINT
INPUT "Dateiname  : "; DN$
OPEN DN$ FOR BINARY AS #1
H = 0
DO WHILE NOT EOF(1)
  GET #1, H + 1, X
  H = H + 4
   FOR P = 1 TO 4
     UMWL$ = MID$(MKS$(X), P, 1)
     WERT(H + P - 5) = ASC(UMWL$)
   NEXT P
LOOP
CLOSE #1
RETURN
REM das obere scheint zu klappen!!!!
REM---------------------------------------------------------------
REM Lesen einer Datei fuer den Datenspeicher binaer
DSBINLE:
CLS
LOCATE 5, 5
PRINT "Lesen einer Datei fuer den Datenspeicher des AT 89 S 8252"
PRINT
PRINT "    Bereich  0 ... 7FFH   ( 2048 Byte )"
PRINT
INPUT "Dateiname  : "; DN$
OPEN DN$ FOR BINARY AS #1
H = 0
 DO WHILE NOT EOF(1)
   GET #1, H + 1, X
   H = H + 4
   FOR P = 1 TO 4
     UMWL$ = MID$(MK$(X), P, 1)
     WERT(H + P - 5) = ASC(UMWL$)
   NEXT P
 LOOP
CLOSE #1
RETURN
REM---------------------------------------------------------------
DATSP:
CLS
LOCATE 3, 1
PRINT " S p e i c h e r n   e i n e r   D a t e i   a u f   D i s k"
PRINT
PRINT
PRINT
INPUT " Dateiname   : "; DN$
OPEN DN$ FOR OUTPUT AS #1
FOR V = 0 TO 8191
PRINT #1, MID$(MKI$(WERT(V)), 1, 1);
NEXT V
CLOSE #1
RETURN
REM---------------------------------------------------------------
REM Grundzustand der SPI Schnittstelle herstellen
SPIinit:
OUT port, 0: REM Daten und Takt auf Low
OUT (port + 2), 1: REM Freigabe gesperrt auf High da STB invertiert
LOCATE 21, 1
PRINT " P r o g r a m m i e r i n t e r f a c e   g e s p e r r t "
RETURN
REM-------------------------------------------------------
FREI:
OUT (port + 2), 0: REM Freigabe auf Low (STB ist invertiert)
LOCATE 21, 1
PRINT " P r o g r a m m i e r i n t e r f a c e   f r e i g e g e b e n "
RETURN
REM--------------------------------------------------------
SPIout:
bitw = 128: REM hoechstwertigstes Bit zuerst
OUT (port), 0
FOR k = 1 TO 8
IF (Byte AND bitw) = bitw THEN pw = 1 ELSE pw = 0
OUT (port), pw: REM Datenwert an MOSI anlegen
OUT (port), pw OR 128: REM Takt SCK aktivieren
OUT (port), pw AND 127: REM Takt SCK wieder deaktivieren
bitw = bitw / 2
NEXT k
OUT (port), 0
RETURN
REM----------------------------------------------------------
SPIin:
iwert = 0: REM Inputwert
OUT (port), 0
bitw = 128: REM Anfangswertigkeit
FOR k = 1 TO 8
OUT (port), 0
OUT (port), 128: REM Takt auf High
A = INP(port + 1): REM Wert lesen
IF (A AND 16) = 16 THEN iwert = iwert + bitw
OUT (port), 0: REM Takt wieder auf Low
bitw = bitw / 2
NEXT k
OUT (port), 0
RETURN
REM--------------------------------------------------------
DUMP:
CLS
LOCATE 1, 10
PRINT " S p e i c h e r d u m p   h e x a d e z i m a l "
SLEEP (1)
LOCATE 3, 1
Y = 0
V = 0
DU1:
FOR z = 1 TO 16
IF LEN(HEX$(V)) = 1 THEN PRINT "000";
IF LEN(HEX$(V)) = 2 THEN PRINT "00";
IF LEN(HEX$(V)) = 3 THEN PRINT "0";
PRINT HEX$(V);
PRINT " : ";
FOR V = Y * 16 TO ((Y * 16) + 15)
IF LEN(HEX$(WERT(V))) = 1 THEN PRINT "0";
PRINT HEX$(WERT(V));
PRINT " ";
NEXT V
FOR V = Y * 16 TO ((Y * 16) + 15)
Y$ = CHR$(WERT(V))
IF WERT(V) > 127 THEN PRINT "_"; : GOTO DU4
IF WERT(V) = 0 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 7 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 8 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 9 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 10 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 11 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 12 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 13 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 31 THEN PRINT "."; : GOTO DU4
IF WERT(V) = 127 THEN PRINT "."; : GOTO DU4
PRINT Y$;
DU4:
NEXT V
PRINT
Y = Y + 1
NEXT z
DU2:
A$ = INKEY$
IF A$ = "" THEN GOTO DU2
IF (A$ = "+") AND (Y < 512) THEN GOTO DU1
IF (A$ = "-") AND (Y > 23) THEN Y = Y - 24: V = V - 384: GOTO DU1
IF (A$ = "E") OR A$ = "e" THEN GOTO DU3
GOTO DU2
DU3:
RETURN
REM ----------------------------------------------------------------




